/*
The following indicators should be placed 
JJMASeries.mqh 
PriceSeries.mqh 
in the folder (directory): MetaTrader\experts\include \,
--------------------------------------------------------
and these indicators should be placed
JFatl.mq4 
Heiken Ashi#.mq4
in the folder (directory): MetaTrader\indicators \
*/
//+------------------------------------------------------------------+  
//|                                                   JFatlSpeed.mq4 | 
//|                           Copyright  2006-07,   Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
#property copyright "Copyright  2006-07, Nikolay Kositsin"
#property link "farria@mail.redcom.ru" 
//place indicator in the separate window
#property indicator_separate_window
//a quantity of the indicator buffers
#property indicator_buffers  8
#property indicator_color1  Blue
#property indicator_color2  Magenta
#property indicator_color3  Gray
#property indicator_color4  Purple
#property indicator_color5  Lime 
#property indicator_color6  Tomato 
#property indicator_color7  DarkGreen  
#property indicator_color8  Red
//the thickness of the indicator lines
#property indicator_width1 4
#property indicator_width2 4
#property indicator_width3 4
//the parameters of the horizontal levels of the indicator
#property indicator_level1  0.0
#property indicator_levelstyle 0
#property indicator_levelcolor SlateBlue
//THE INPUT PARAMETERS OF THE INDICATOR OF--------------------------------------------------------------------------------------------------
extern string note1 = "the value of a price change";
extern int Noise = 8; //the value of a price change, taken for noise;
extern string note2 = "depth JFatl of smoothing";
extern int Length = 3; //depth JFatl of smoothing;
extern string note3 = "is changed within limits of -100...100";
extern string note4 = "influence quality transient JFatl process";
extern int Phase = 100; //the parameter, which is changed withinlimits of -100... 100, influence quality transient JFatl process;
extern string note5 = "depth of the smoothing";
extern int LengthS = 1; //the depth of the smoothing of the finishedindicator JFatlSpeed;
extern string note6 = "quality transient JFatlSpeed process";
extern int PhaseS = 100; //the parameter, which is changed withinlimits of -100... 100, influence quality transient JFatlSpeed process;
extern string note7 = "cdvig indicator along the time axis";
extern int Shift = 0; //cdvig indicator along the time axis;
extern string note8 = "vertical displacement of symbols Buy1, Buy2, Sell1, Sell2";
extern int sh = 10; //the vertical displacement of symbols Buy1, Buy2,Sell1, Sell2;
extern string note9 = "0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL";
extern string note10 = "6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL";
extern string note11 = "9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW";
extern string note12 = "11-Heiken Ashi Low, 12-Heiken Ashi High";
extern string note13 = "13-Heiken Ashi Open, 14-Heiken Ashi Close";
extern int Input_Price_Customs = 0;//Input of prices, on which is produced the calculation of the indicator:
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 10-0.5*TRENDFOLLOW,
//11-Heiken Ashi Low, 12-Heiken Ashi High,  13-Heiken Ashi Open, 14-Heiken Ashi Close.)
//---- -------------------------------------------------------------------------------------------------------------------------------+
//the indicator buffers
double JFatlSpeed1[]; 
double JFatlSpeed2[];
double JFatlSpeed3[];
double JFatlSpeed4[];
double Buy1       [];
double Sell1      [];
double Buy2       [];
double Sell2      [];
//the entire variables
int    SH; 
//+------------------------------------------------------------------+  
//introduction to function JJMASeries
//introduction to function JJMASeriesResize
//introduction to function JJMASeriesAlert
//introduction to function JMA_.ErrDescr
#include <JJMASeries.mqh> 
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+ 
int init() 
{ 
//the style of the performance of lines in the form of the histogram
SetIndexStyle(0,DRAW_HISTOGRAM,STYLE_SOLID);
SetIndexStyle(1,DRAW_HISTOGRAM,STYLE_SOLID);
SetIndexStyle(2,DRAW_HISTOGRAM,STYLE_SOLID);
SetIndexStyle(3,DRAW_HISTOGRAM,STYLE_SOLID);
//the style of the performance of graph the form of the symbols
SetIndexStyle(4,DRAW_ARROW);
SetIndexStyle(5,DRAW_ARROW);
SetIndexStyle(6,DRAW_ARROW);
SetIndexStyle(7,DRAW_ARROW);
//the determination of the style of the point targets
SetIndexArrow(4,108);
SetIndexArrow(5,108);
SetIndexArrow(6,233);
SetIndexArrow(7,234);
//8 indicator buffers are used for the calculation
IndicatorBuffers(8);
SetIndexBuffer(0,JFatlSpeed1);
SetIndexBuffer(1,JFatlSpeed2);
SetIndexBuffer(2,JFatlSpeed3);
SetIndexBuffer(3,JFatlSpeed4);
SetIndexBuffer(4,Buy1);
SetIndexBuffer(5,Sell1);
SetIndexBuffer(6,Buy2);
SetIndexBuffer(7,Sell2); 
//the installation of the number of the bar, beginning from which willotrisovyvat'sya the indicator
SetIndexDrawBegin(0,69); 
SetIndexDrawBegin(1,69);
SetIndexDrawBegin(2,69);
SetIndexDrawBegin(3,69);
SetIndexDrawBegin(4,69);
SetIndexDrawBegin(5,69);
SetIndexDrawBegin(6,69);
SetIndexDrawBegin(7,69);
SH=sh+Noise;
//the installation of Alerts at the inadmissible values of theexternal variables
JJMASeriesAlert (0,"LengthS",LengthS);
JJMASeriesAlert (1,"PhaseS", PhaseS);
//the installation of the size of accuracy (quantity of signs afterdecimal point) for the visualization of the values of the indicator
IndicatorDigits(0);
//a change in the sizes of the buffer variables of functionJJMASeries, nJMAnumber=1(Odno turning to function JJMASeries)
if (JJMASeriesResize(1)!=1)return(-1);
//the completion of the initialization
return(0); 
}
//+------------------------------------------------------------------+ 
//| JFATL SPEED                                                      |
//+------------------------------------------------------------------+  
int start() 
{ 
//the introduction of variables with the floating point
double JFatlSpeed,JFS0,JFS1,trend,JFatl0,JFatl1,Series;
//the introduction of entire variables and obtaining the alreadycalculated bars
int reset,MaxBar,limit,counted_bars=IndicatorCounted();
//checking to the possible errors
if (counted_bars<0)return(-1);
//the last calculated bar must be converted
if (counted_bars>0) counted_bars--;
//the determination of the number of the oldest bar, beginning fromwhich there will be proizeden the conversion of the new bars
limit=Bars-counted_bars-1; MaxBar=Bars-1;
//----+   
for(int k=limit;k>=0;k--)
{
JFatl0= iCustom( NULL, 0, "JFatl",Length,Phase,Shift,0,Input_Price_Customs,0,k+0); 
JFatl1= iCustom( NULL, 0, "JFatl",Length,Phase,Shift,0,Input_Price_Customs,0,k+1);      
Series=(JFatl0-JFatl1)/Point;
//the turning to function JJMASeries after number 0, parametersnJMA.Phase and nJMA.Length do not change on each bar (nJMA.din=0)
JFatlSpeed=JJMASeries(0,0,MaxBar,limit,PhaseS,LengthS,Series,k,reset);
//checking to the absence of error in the previous operation
if(reset!=0)return(-1);   
 
JFS1=JFatlSpeed1[k+1]+JFatlSpeed2[k+1]+JFatlSpeed3[k+1]+JFatlSpeed4[k+1];
JFS0=JFatlSpeed;
//----+

if (MathAbs(JFS1)<=Noise)
  { 
  if(JFS0> Noise)Buy2 [k]=-SH; else Buy2 [k]=EMPTY_VALUE;
  if(JFS0<-Noise)Sell2[k]= SH; else Sell2[k]=EMPTY_VALUE;
  }
else
  {
  if((JFS1<-Noise)&&(MathAbs(JFS0)<=Noise))Buy1 [k]=-SH; else Buy1 [k]=EMPTY_VALUE;
  if((JFS1> Noise)&&(MathAbs(JFS0)<=Noise))Sell1[k]= SH; else Sell1[k]=EMPTY_VALUE;
  if((JFS1<-Noise)&&(JFS0> Noise))Buy2 [k]=-SH; else Buy2 [k]=EMPTY_VALUE;
  if((JFS1> Noise)&&(JFS0<-Noise))Sell2[k]= SH; else Sell2[k]=EMPTY_VALUE; 
  }
//----+
if(MathAbs(JFatlSpeed)<=Noise){JFatlSpeed4[k]=JFatlSpeed; JFatlSpeed=0;}
if(MathAbs(JFatlSpeed)> Noise) JFatlSpeed4[k]=0; 
//----+
//----+ +SSSSSSSSSSSSSSSS <<< Three colored code >>> SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
trend=JFatlSpeed-JFatlSpeed1[k+1]-JFatlSpeed2[k+1]-JFatlSpeed3[k+1];     
if(trend>0.0)     {JFatlSpeed1[k]=JFatlSpeed;JFatlSpeed2[k]=0.0;       JFatlSpeed3[k]=0.0;}
else{if(trend<0.0){JFatlSpeed1[k]=0.0;       JFatlSpeed2[k]=JFatlSpeed;JFatlSpeed3[k]=0.0;}
else              {JFatlSpeed1[k]=0.0;       JFatlSpeed2[k]=0.0;       JFatlSpeed3[k]=JFatlSpeed;}}    
//----+ +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+ 
}
//----+
return(0); 
} 
//+-------------------------------------------------------------------------+


